﻿using System;

namespace Mindbus
{
  public class DropDownDataType : umbraco.cms.businesslogic.datatype.BaseDataType, umbraco.interfaces.IDataType
  {
    private umbraco.interfaces.IDataEditor _Editor;
    private umbraco.interfaces.IData _baseData;
    private DropDownPrevalueEditor _prevalueeditor;

    public override umbraco.interfaces.IDataEditor DataEditor
    {
      get
      {
        if (_Editor == null)
          _Editor = new DropDownDataEditor(Data, ((DropDownPrevalueEditor)PrevalueEditor).Configuration);
        return _Editor;
      }
    }

    public override umbraco.interfaces.IData Data
    {
      get
      {
        if (_baseData == null)
          _baseData = new umbraco.cms.businesslogic.datatype.DefaultData(this);
        return _baseData;
      }
    }
    public override Guid Id
    {
      get { return new Guid("68C0FD54-4804-4864-938E-1A8A82069D01"); }
    }

    public override string DataTypeName
    {
      get { return "DropDownWithSqlSource"; }
    }

    public override umbraco.interfaces.IDataPrevalue PrevalueEditor
    {
      get
      {
        if (_prevalueeditor == null)
          _prevalueeditor = new DropDownPrevalueEditor(this);
        
        return _prevalueeditor;
      }
    }
  }
}
